# Códigos de Error

Esta página contiene todos los códigos de error que el 'launcher' podría mostrar.

---

Código | Descripción | Posible Solución
--- | --- | ---
10054 | Conexión reiniciada por el 'peer' | El servidor al que te estabas conectando ha sido apagado.
Error al encontrar el juego, por favor, ábrelo. Reporta esto si el problema persiste, código 3. | El 'launcher' ha sido incapaz de encontrar la información del juego (directorio del juego, directorio del perfil, versión, etc...) en la entrada del registro | Abre el juego al menos una vez para que los valores del registro sean creados.
Error al encontrar el juego, por favor, ábrelo. Reporta esto si el problema persiste, código 4. | El 'launcher' ha sido incapaz de encontrar la información del juego (directorio del juego, directorio del perfil, versión, etc...) en la entrada del registro | Este error es más propenso a aparecer en jugadores que usen **copias pirateadas** del juego. Si has comprado el juego, ábrelo al menos una vez para que las entradas del registro sean creadas.
¡No se ha podido abrir el juego!. El 'Launcher' se cerrará en breves. | El 'launcher' fue incapaz de encontrar el ejecutable del juego. | Abre el juego al menos una vez antes de ejecutar el 'launcher' de vuelta.
¡Juego cerrado! El 'launcher' se cerrará en breves. | El juego ha sido cerrado | Este mensaje aparecerá cuando se cierre el juego o el juego falle al iniciarse.
¡Actualización del 'launcher' fallida! | El 'launcher' ha fallado al descargar una nueva versión | Comprueba tu conexión a internet y ajustes de firewall / antivirus para asegurarte de que el 'launcher' no esté bloqueado.
Error al iniciar el archivo de registro | El 'launcher' no tiene permisos para crear archivos | Ejecuta el 'launcher' como Administrador.
Por favor, cierra el juego y vuélvelo a intentar | El juego ya está abierto y el 'launcher' no puede limpiar la carpeta`multiplayer/mods` | Cierra el juego y vuélvelo a intentar.
Por favor inicia el juego al menos una vez | El 'launcher' intentó y falló al modificar el directorio del juego | Abre el juego al menos una vez antes de iniciar el 'launcher' de nuevo.
¡Servidores Primarios Sin Conexión! ¡Disculpa los inconvenientes! | El 'launcher' falló al buscar actualizaciones | Comprueba tu conexión a internet y reglas del firewall. Si no hay problemas por tu parte, comprueba el canal de [BeamMP updates channel](https://discord.com/channels/601558901657305098/697596153943949352) en nuestro Discord.
¡Sistema Backend Fuera de Servicio! ¡No te preocupes, volverá pronto! | El backend de BeamMP no ha respondido | Comprueba tu conexión a internet y reglas del firewall. Si no hay problemas por tu parte, comprueba el canal de [BeamMP updates channel](https://discord.com/channels/601558901657305098/697596153943949352) en nuestro Discord.
Atascado al actualizar | El 'launcher' se ha atascado en una actualización y no puede continuar al siguiente paso | Ejecuta el 'launcher' como administrador y comprueba las reglas de tu antivirus para que este no esté bloqueado.

Si el 'launcher' se cierra inmediatamente, comprueba el archivo `Launcher.log` en la carpeta donde hayas instalado BeamMP.
