# F.A.Q.
List of commonly asked questions.

---
## **Client**

---
### **How do I install BeamMP?**

There is a full guide on how to install BeamMP on Windows, you can find it [here](https://docs.beammp.com/game/getting-started/).

---
### **Does BeamMP work on a cracked version of BeamNG?**

BeamMP will not work with pirated or outdated versions of BeamNG.drive.
The BeamMP support team does not offer support for issues with pirated / outdated copies.

---
### **Does BeamMP work on linux?**

The Client is not officially supported on Linux. However, you can follow our [guide on how to use BeamMP on Linux](../game/getting-started/#2b-linux-installation)

---
### **Why is the launcher flagged by my antivirus or by Windows Defender**

Some antivirus programs may flag BeamMP as a threat, due to it interacting with the network and other stuff. There are **no viruses** in any of the code. The code for the launcher, server, and lua client can be found on our [GitHub](https://github.com/BeamMP).

---
### **I have poor gameplay performance, what should I do?**

We are working hard to make the Multiplayer experience as stable as possible. If you have already lowered your graphic settings and your performance is still poor, consider playing on a server with less players. The game is mainly CPU bound when you play with lots of people, so older CPUs (even quadcores) will suffer with more than a handful of people. (General Rule of Thumb: 1 car per CPU Thread)

---
## **Miscellaneous**

---
### **Where can I find the code?**

All the source code can be found on our [GitHub](https://github.com/BeamMP).
Before making any changes, keep in mind that the code is subject to our [Terms of Use](https://forum.beammp.com/t/terms-of-use-v1-0/43) and licenses:

|   Code     | License                                                                    |
|------------|:--------------------------------------------------------------------------:|
| Server     | [LICENSE](https://github.com/BeamMP/BeamMP-Server/blob/master/LICENSE)     |
| Launcher   | [LICENSE](https://github.com/BeamMP/BeamMP-Launcher/blob/master/LICENSE) |
| Client Lua | [LICENSE](https://github.com/BeamMP/BeamMP/blob/development/LICENSE)    |

---
### **I have found a bug or an exploit what should I do?**

If the issue is code related and you know how to use Github, open a new "Issue" in the appropriate repository on our [GitHub](https://github.com/BeamMP). We use an issue-based workflow so even if you already have a fix for the bug, consider opening a new "Issue", then open a "Pull Request" with the solutions for the issue. More info on contributing can be found [here](https://github.com/BeamMP/BeamMP/blob/development/CONTRIBUTING.md).

If you don't have a GitHub account or you don't know how to use GitHub or have any other questions, you can get in touch with us in the following ways:

- If it is not something sensitive, you can create a post on our [BeamMP Forum](https://forum.beammp.com) or you can report this on our [Official Discord](https://discord.gg/beammp).
- If the information is sensitive you can directly report the issue to a Staff member on our [Discord](https://discord.gg/beammp).
